#ifndef IKD_DIX_SP_BASE_H
#define IKD_DIX_SP_BASE_H

// NXgX}[gۂ^NǗ
// : IKD
// HP    : http://marupeke296.com

// o[W
// v1.00
// EoBŒ̃\bhB



namespace Dix {
	class sp_base {
	protected:
		mutable sp_base *pre, *next;

	protected:
		sp_base() : pre(), next() {}
		virtual ~sp_base() {
			remove();
		}

		// ̃AhXn
		sp_base *getThis() const {
			return (sp_base*)this;
		}

		// ̃Xgɉ
		void join(const sp_base &src) const {
			// ܂ɓƗĂ炤
			src.remove();
			// 莩g̃AhX擾
			sp_base* srcPtr = src.getThis();
			// ׂ̗ɂłɒNqĂÅԂɑ
			if (next) {
				srcPtr->next = next;
				srcPtr->pre  = (sp_base*)this;
				next->pre    = srcPtr;
				next         = srcPtr;
				return;
			}
			// ׂ̗͒NȂ̂ł̂܂܌q
			next = srcPtr;
			srcPtr->pre = (sp_base*)this;
		}

		// 𗣂ĕ
		bool remove() const {
			if (!pre && !next)
				return true;	// Ō̈lł
			if (pre)
				pre->next = next;
			if (next)
				next->pre = pre;
			pre = next = 0;
			return false;	// Ԃ܂܂
		}
	};
}

#endif